Invokes the ionCube Encoder (PHP4 or PHP5)

Use Project#createTask to register a new Task.

author | Michiel Rook
author | Andrew Eddie
author | Domenico Sgarbossa
version | $Id: b72d02e8f0d73e9a0533c249bcee161beeca5fb0 $
package | phing.tasks.ext.ioncube
since | 2.2.0
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Adds a comment to be used in encoded files

    addComment(\IoncubeComment $comment)

### Parameters

#### $comment

## Returns the action-if-no-loader option

    getActionIfNoLoader()

## Returns the allow-encoding-into-source option

    getAllowEncodingIntoSource()

## Returns the allowed server setting

    getAllowedServer()

## Returns the binary option

    getBinary()

## Returns the callback-file option

    getCallbackFile()

## Returns the copy setting

    getCopy()

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()

### Returns

`string`The text description of the task

## Returns the encode setting

    getEncode()

## Returns regexps of additional files to encrypt (separated by space)

    getEncrypt()

## Returns the expireIn setting

    getExpirein()

## Returns the expireOn setting

    getExpireon()

## Returns the source directory

    getFromDir()

## Returns the ignore setting

    getIgnore()

## Returns the ignore-deprecated-warnings option

    getIgnoreDeprecatedWarnings()

## Returns the ignore-strict-warnings option

    getIgnoreStrictWarnings()

## Returns the path to the ionCube encoder

    getIoncubePath()

## Returns the ignore setting

    getKeep()

## Returns the path to the license file to use

    getLicensePath()

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the message-if-no-loader option

    getMessageIfNoLoader()

## Returns the no-doc-comments option

    getNoDocComments()

## Returns the no-short-open-tags option

    getNoShortOpenTags()

## Returns the optimize option

    getObfuscate()

## Returns the obfuscation-exclusions-file option

    getObfuscationExclusionFile()

## Returns the optimize option

    getObfuscationKey()

## Returns the optimize option

    getOptimize()

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns the passphrase to use when encoding files

    getPassPhrase()

## Returns the version of PHP to use (defaults to 5)

    getPhpVersion()

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns he option to use when encoding target directory already exists (defaults to none)

    getTargetOption()

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Returns the target directory

    getToDir()

## Returns the without-runtime-loader-support option

    getWithoutRuntimeLoaderSupport()

## Called by the parser to let the task initialize properly.

    init()

Inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

inherited_from | \Task::init()

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## The main entry point

    main()

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

### Exceptions

`\BuildException` |

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()

## Sets the action-if-no-loader option

    setActionIfNoLoader($value)

### Parameters

#### $value

## Sets the allow-encoding-into-source option

    setAllowEncodingIntoSource($value)

### Parameters

#### $value

## Sets the allowed server

    setAllowedServer($value)

### Parameters

#### $value

## Sets the binary option

    setBinary($value)

### Parameters

#### $value

## Sets the callback-file option

    setCallbackFile($value)

### Parameters

#### $value

## Sets files or folders to copy (separated by space)

    setCopy($value)

### Parameters

#### $value

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Sets additional file patterns, files or directories to encode, or to reverse the effect of copy (separated by space)

    setEncode($value)

### Parameters

#### $value

## Sets regexps of additional files to encrypt (separated by space)

    setEncrypt($value)

### Parameters

#### $value

## Sets a period after which the files expire

    setExpirein($value)

### Parameters

#### $value

## Sets a YYYY-MM-DD date to expire the files

    setExpireon($value)

### Parameters

#### $value

## Sets the source directory

    setFromDir($value)

### Parameters

#### $value

## Set files and directories to ignore entirely and exclude from the target directory (separated by space).

    setIgnore($value)

### Parameters

#### $value

## Sets the ignore-deprecated-warnings option

    setIgnoreDeprecatedWarnings($value)

### Parameters

#### $value

## Sets the ignore-strict-warnings option

    setIgnoreStrictWarnings($value)

### Parameters

#### $value

## Sets the path to the ionCube encoder

    setIoncubePath($value)

### Parameters

#### $value

## Set files and directories not to be ignored (separated by space).

    setKeep($value)

### Parameters

#### $value

## Sets the path to the license file to use

    setLicensePath($value)

### Parameters

#### $value

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the message-if-no-loader option

    setMessageIfNoLoader($value)

### Parameters

#### $value

## Sets the no-doc-comments option

    setNoDocComments($value)

### Parameters

#### $value

## Sets the no-short-open-tags option

    setNoShortOpenTags($value)

### Parameters

#### $value

## Sets the obfuscate option

    setObfuscate($value)

### Parameters

#### $value

## Sets the obfuscation-exclusions-file option

    setObfuscationExclusionFile($value)

### Parameters

#### $value

## Sets the obfuscation key (required if using the obfuscate option)

    setObfuscationKey($value)

### Parameters

#### $value

## Sets the optimize option

    setOptimize($value)

### Parameters

#### $value

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## Sets the passphrase to use when encoding files

    setPassPhrase($value)

### Parameters

#### $value

## Sets the version of PHP to use (defaults to 5)

    setPhpVersion($value)

### Parameters

#### $value

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets whether to show command line before it is executed

    setShowCommandLine($value)

### Parameters

#### $value

## Sets the option to use when encoding target directory already exists (defaults to none)

    setTargetOption($targetOption)

### Parameters

#### $targetOption

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Sets the target directory

    setToDir($value)

### Parameters

#### $value

## Sets the without-runtime-loader-support option

    setWithoutRuntimeLoaderSupport($value)

### Parameters

#### $value

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()

### Parameters

#### $slotName

`string`

## Constructs an argument string for the ionCube encoder

    constructArguments()

### Properties

##

    $description : string

Inherited

inherited_from | \Task::$$description

##

    $location : \Location

Inherited

inherited_from | \Task::$$location

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project

##

    $target : \Target

Inherited

inherited_from | \Task::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper

##

    $comments

##

    $encoderName

##

    $fromDir

##

    $ionOptions

##

    $ionOptionsXS

##

    $ionSwitches

##

    $ioncubePath

##

    $phpVersion

##

    $showCommandLine

##

    $targetOption

##

    $toDir